---
title: HTMLMediaElement.setSinkId()
slug: Web/API/HTMLMediaElement/setSinkId
tags:
  - API
  - Audio
  - Experimental
  - HTMLMediaElement
  - Media
  - Method
  - Reference
  - setSinkId
---
<p>{{APIRef("HTML DOM")}} {{SeeCompatTable}}</p>

<p>The <strong><code>HTMLMediaElement.setSinkId()</code></strong> method sets the ID of the audio device to use for output and returns a <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise" title="The Promise object is used for deferred and asynchronous computations. A Promise represents an operation that hasn't completed yet, but is expected in the future."><code>Promise</code></a>. This only works when the application is authorized to use the specified device.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>HTMLMediaElement</em>.setSinkId(<em>sinkId</em>).then(function() { ... })</pre>

<h3 id="Returns">Returns</h3>

<p>A {{jsxref("Promise")}} that resolves to {{jsxref("undefined")}}.</p>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>sinkId</dt>
 <dd>The {{domxref("MediaDeviceInfo.deviceId")}} of the audio output device.</dd>
</dl>

<h3 id="Exceptions">Exceptions</h3>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Exception</th>
   <th scope="col">Explanation</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{domxref("DOMException")}}</td>
   <td>No permission to use the requested device</td>
  </tr>
 </tbody>
</table>

<h2 id="Examples">Examples</h2>

<pre class="brush:js">const devices = await navigator.mediaDevices.enumerateDevices();
const audioDevices = devices.filter(device =&gt; device.kind === 'audiooutput');
const audio = document.createElement('audio');
await audio.setSinkId(audioDevices[0].deviceId);
console.log('Audio is being played on ' + audio.sinkId);
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th>Specification</th>
   <th>Status</th>
   <th>Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Audio Output','#dom-htmlmediaelement-setsinkid','sinkId')}}</td>
   <td>{{Spec2('Audio Output')}}</td>
   <td>Initial definition. Older versions of this spec were called "Media Capture Output".</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.HTMLMediaElement.setSinkId")}}</p>
